%define gitversion 21c7e2c

Name: rstudio
Version: 0.98.978
Release: %mkrel 8
Summary: RStudio IDE is a powerful and productive user interface for R
Group: Sciences/Mathematics
License: GPLv3
URL: http://www.rstudio.com/
Source: %{name}-v%{version}.tgz
#SourceGet: https://github.com/rstudio/rstudio/archive/v%%{version}.tar.gz
Source1: https://s3.amazonaws.com/rstudio-dictionaries/core-dictionaries.zip
Source2: https://s3.amazonaws.com/rstudio-buildtools/mathjax-20.zip
Source3: https://s3.amazonaws.com/rstudio-buildtools/gin-1.5.zip
Source4: rmarkdown-0.1.2.tar.gz
#SourceGet4: https://github.com/rstudio/rmarkdown/archive/v0.1.2.tar.gz
Source5: packrat-0.4.0.tar.gz
#SourceGet5: https://github.com/rstudio/packrat/tarball/c7d2e00

#This is a stripped version of gwt from
#https://s3.amazonaws.com/rstudio-buildtools/gwt-2.6.0.zip
Source6: gwt-2.6.0-deps.zip
Patch0: cmakefile-remove-pandoc.diff 


BuildRequires: cmake
BuildRequires: boost-devel
BuildRequires: icu-devel
BuildRequires: java-devel
BuildRequires: pam-devel
BuildRequires: qt4-devel
BuildRequires: R-base
BuildRequires: ant
BuildRequires: pkgconfig(QtWebKit)
BuildRequires: pkgconfig(fontconfig)
BuildRequires: pkgconfig(freetype2)
BuildRequires: pkgconfig(glib-2.0)
BuildRequires: pkgconfig(liblzma)
BuildRequires: pkgconfig(libpcre)
BuildRequires: pkgconfig(libpng)
BuildRequires: pkgconfig(libxml-2.0)
BuildRequires: pkgconfig(sqlite3)
BuildRequires: pkgconfig(uuid)
BuildRequires: gwt
Requires: R-base
Requires: rstudio-common

%description
RStudio is a free and open source integrated development environment for R.

%package server
Summary: RStudio IDE is a powerful and productive user interface for R
Group: Sciences/Mathematics
License: GPLv3
URL: http://www.rstudio.com/
Requires: R-base
Requires: rstudio-common

%description server
RStudio is a free and open source integrated development environment for R.

%package common
Summary: RStudio IDE is a powerful and productive user interface for R
Group: Sciences/Mathematics
License: GPLv3
URL: http://www.rstudio.com/
Requires: R-base

%description common
RStudio is a free and open source integrated development environment for R.

%prep
%setup -q -n rstudio-%{version}
%patch0 -p1
mkdir -p dependencies/common/dictionaries
unzip -qd dependencies/common/dictionaries %{SOURCE1}
mkdir -p dependencies/common/mathjax
unzip -qd dependencies/common/mathjax %{SOURCE2}
mkdir -p src/gwt/lib/gwt
unzip -qd src/gwt/lib/gwt %{SOURCE6}
mv src/gwt/lib/gwt/gwt-2.6.0 src/gwt/lib/gwt/2.6.0
pushd src/gwt/lib/gwt/2.6.0
ln -s /usr/share/java/gwt/*.jar .
popd
mkdir -p src/gwt/lib/gin/1.5
unzip -qd src/gwt/lib/gin/1.5 %{SOURCE3}
pushd dependencies/common
tar xzf %{SOURCE4}
mv rmarkdown-* rmarkdown
tar xzf %{SOURCE5}
mv rstudio-packrat-* packrat
popd

# Fix for build with boost-1.59/60
# specify that namespace core is in the global namespace and not
# relative to some other namespace (like its ::core not ::boost::core)
find . \( -name *.cpp -or -name *.hpp \) -exec sed \
        -e 's@<core::@< ::core::@g' -e 's@\([^:]\)core::@\1::core::@g' -i {} \;

%build
pushd .
%cmake \
-DRSTUDIO_TARGET=Desktop \
-DCMAKE_INSTALL_PREFIX=%{_libdir}/%{name}
make %{?_smp_mflags}
popd

pushd .
%cmake \
-DRSTUDIO_TARGET=Server \
-DCMAKE_INSTALL_PREFIX=%{_libdir}/%{name}-server

make %{?_smp_mflags}
popd

%install
pushd .
%cmake \
-DRSTUDIO_TARGET=Desktop \
-DCMAKE_INSTALL_PREFIX=%{_libdir}/%{name}
%makeinstall_std 

mkdir -p %{buildroot}%{_bindir}
ln -s %{_libdir}/%{name}-server/bin/%{name}-server %{buildroot}%{_bindir}/%{name}-server
ln -s %{_libdir}/%{name}/bin/%{name} %{buildroot}%{_bindir}/%{name}


# The default one is too ugly
rm -f %{buildroot}%{_datadir}/applications/%{name}.desktop
cat > %{buildroot}%{_datadir}/applications/mageia-%{name}.desktop << EOF
[Desktop Entry]
Name=RStudio
Comment=IDE for R
Exec=%{_bindir}/rstudio
Icon=rstudio
Type=Application
Terminal=false
Categories=Science;Math;X-MageiaLinux-MoreApplications-Sciences-Mathematics;
MimeType=text/x-r-source;text/x-r;text/x-R;text/x-r-doc;text/x-r-sweave;text/x-r-markdown;text/x-r-html;application/x-r-data;application/x-r-project;text/x-r-history;text/x-r-profile;text/x-tex;text/x-markdown;text/html;text/css;text/javascript;
EOF
popd

%cmake \
-DRSTUDIO_TARGET=Server \
-DCMAKE_INSTALL_PREFIX=%{_libdir}/%{name}-server
%makeinstall_std
ln -s %{_libdir}/%{name}-server/bin/rserver %{buildroot}%{_bindir}/rserver

%files
%doc README.md COPYING
%{_bindir}/%{name}
%{_libdir}/%{name}
%{_datadir}/applications/mageia-%{name}.desktop

%files server
%{_bindir}/%{name}-server
%{_bindir}/rserver
%{_libdir}/%{name}-server

%files common
%{_datadir}/mime/packages/%{name}.xml
%{_datadir}/pixmaps/%{name}.png
%{_iconsdir}/hicolor/*/apps/%{name}.png
%{_iconsdir}/hicolor/*/mimetypes/application-x-r-*.png


%changelog
* Wed Mar 15 2017 mrambo3501 <mrambo3501> 0.98.978-8.mga6
+ Revision: 1092807
- Rebuild for icu-58.2

* Sat May 14 2016 shlomif <shlomif> 0.98.978-7.mga6
+ Revision: 1015265
- Rebuild for the new UCI (new major)

* Thu Mar 03 2016 umeabot <umeabot> 0.98.978-6.mga6
+ Revision: 984098
- Rebuild for openssl

* Wed Feb 17 2016 umeabot <umeabot> 0.98.978-5.mga6
+ Revision: 963744
- Mageia 6 Mass Rebuild
- Second Mageia 5 Mass Rebuild

  + barjac <barjac>
    - add partial fix for boost-1.59/60 builds

  + daviddavid <daviddavid>
    - rebuild for new boost-1.58.0

* Tue Sep 16 2014 umeabot <umeabot> 0.98.978-2.mga5
+ Revision: 688726
- Mageia 5 Mass Rebuild

* Fri Aug 01 2014 joequant <joequant> 0.98.978-1.mga5
+ Revision: 658857
- update version to 0.98.978

* Wed Apr 16 2014 joequant <joequant> 0.98.501-2.mga5
+ Revision: 615245
- add link to rserver

* Sat Apr 12 2014 joequant <joequant> 0.98.501-1.mga5
+ Revision: 613640
- add ant to build requires
- single thread make
- single thread make
- add QtWebKit
- imported package rstudio

